﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace GFramework.Base
{
    public class FPSCounter
    {
        private TimeSpan _lastTime = new TimeSpan(0,0,0,0);
        private SpriteFont _font;
        private SpriteBatch _batch;
        private int _counter;
        int _fps = 25;
        Vector2 _position = new Vector2(10,10);

		public int? TrianglesCount
		{
			set; private get;
		}

        public void LoadContent()
        {
            _font = GameManager.Instance.Game.Content.Load<SpriteFont>(@"Fonts\Times New Roman");
        }

        public void Draw(GameTime time, SpriteBatch batch)
        {
            _lastTime += time.ElapsedRealTime; 
            if (_lastTime.TotalSeconds>=1)
            {
                _fps = _counter;
                _lastTime = new TimeSpan(0);
                _counter = 0;
            }
            _counter++;

            batch.DrawString(Fonts.TimesNewRoman, _fps.ToString() + " FPS", _position, Color.Black);
            batch.DrawString(Fonts.TimesNewRoman, _fps.ToString() + " FPS", _position+Vector2.One, Color.White);
			if (TrianglesCount.HasValue)
			{
				string trStr = " Triangles: " + TrianglesCount.ToString();
				batch.DrawString(Fonts.TimesNewRoman,trStr , _position+new Vector2(0,20), Color.Black);
				batch.DrawString(Fonts.TimesNewRoman, trStr, _position + Vector2.One + new Vector2(0, 20), Color.White);
			}
        }
    }
}
