﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GFramework.Camera;
using GFramework.Input;
using Microsoft.Xna.Framework;

namespace GFramework.Base
{
    public class GameManager:GameComponent, IGameManager
    {
        private MouseIO _mouse;
        private Keyboard _keyboard;
        private ActionKeyMapper _actions;
        private CameraManager _camManager;

        public MouseIO MouseManager { get { return _mouse; } }
        public Keyboard Keyboard { get { return _keyboard; } }
        public ActionKeyMapper ActionMapper { get { return _actions; } }
        public CameraManager CameraManager { get { return _camManager; } }

        public GameManager(Game game):base(game)
        {
            _mouse = new MouseIO();
            _keyboard = new Keyboard();
            _actions = new ActionKeyMapper();
            _camManager = new CameraManager();
            //TODO:Здесь должна быть нормальная инициализация,а не эта заглушка
            _actions.AddDefaultActions(); 
        }

        public override void Initialize()
        {
            _actions.Initialize();
            base.Initialize();
        }

        public static void InitializeGamemanagement(Game game)
        {
            Instance = new GameManager(game);
        }

        public static GameManager Instance
        { get; private set; }

        public override void Update(GameTime gameTime)
        {
            _mouse.Update();
            _keyboard.Update(gameTime);
            base.Update(gameTime);
        }
       
    }
}
