﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GFramework.Base;
using GFramework.Input;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace GFramework.UI
{
    public class UserInterface:DrawableGameComponent
    {
        private SpriteBatch _sb;
        private Texture2D _cursorTex;
        private FPSCounter _counter;

        public UserInterface(Game game) : base(game)
        {
            UpdateOrder = 0;
            DrawOrder = 3;
        }

        protected override void LoadContent()
        {
            _sb = new SpriteBatch(Game.GraphicsDevice);
            _cursorTex = Game.Content.Load<Texture2D>(@"UIElements\cursor");
            Fonts.LoadContent();
            GameManager.Instance.MouseManager.CurrentCursor = _cursorTex;
        }

        public static UserInterface UI { get; private set; }

        public override void Initialize()
        {
            _counter = new FPSCounter();
            base.Initialize();
            UI = this;
        }

    	public int TrianglesCount
    	{
    		set
    		{
    			_counter.TrianglesCount = value;
    		}
    	}

        public override void Draw(GameTime gameTime)
        {
            _sb.Begin();
            GameManager.Instance.MouseManager.Draw(_sb);
            _counter.Draw(gameTime, _sb);
            _sb.End();
        }
    }
}
