﻿using System;
using System.Collections.Generic;
using System.Linq;
using GFramework.Base;
using GFramework.Camera;
using GFramework.Environment;
using GFramework.Input;
using GFramework.UI;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using Environment=GFramework.Environment.Environment;

namespace GameTesting
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        private Model model;
        private Effect effect;

        private Environment _environment;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            graphics.SynchronizeWithVerticalRetrace = true;
            //graphics.PreferredBackBufferWidth = 1680;
            //graphics.PreferredBackBufferHeight = 1050;
            //graphics.IsFullScreen = true;
            
        }

        //Camera camera;
        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            var ui = new UserInterface(this);
            GameManager.InitializeGamemanagement(this);
            Components.Add(GameManager.Instance);

            _environment = new Environment(this);
            Components.Add(_environment);
            Components.Add(ui);
            base.Initialize();
            GameManager.Instance.CameraManager.AddMouseCamera(new Vector3(0f, 500, 0.001f), new Vector3(0, 300, 0));
            GameManager.Instance.MouseManager.MouseButtonsPressed += new EventHandler<GFramework.Input.MouseButtonEventArgs>(MouseManager_MouseButtonsPressed);
            GameManager.Instance.MouseManager.MouseButtonsReleased += new EventHandler<GFramework.Input.MouseButtonEventArgs>(MouseManager_MouseButtonsReleased);

            GameManager.Instance.ActionMapper.ActionFired += new EventHandler<ActionEventArgs>(ActionMapper_ActionFired);
        }

        void ActionMapper_ActionFired(object sender, ActionEventArgs e)
        {
            switch (e.ActionName)
            {
                case ActionNames.EXIT1:
                case ActionNames.EXIT2:
                case ActionNames.EXIT3:
                    this.Exit();
                    return;
            }
        }

        private Point lastPosition;
        void MouseManager_MouseButtonsReleased(object sender, GFramework.Input.MouseButtonEventArgs e)
        {
            if ((e.Buttons & MouseButtons.Right) == MouseButtons.Right)
            {
                Mouse.SetPosition(lastPosition.X,lastPosition.Y);
                GameManager.Instance.MouseManager.DrawMouse = true;
            }
        }

        void MouseManager_MouseButtonsPressed(object sender, GFramework.Input.MouseButtonEventArgs e)
        {
            if ((e.Buttons & MouseButtons.Right) == MouseButtons.Right)
            {
                GameManager.Instance.MouseManager.DrawMouse = false;
                lastPosition = GameManager.Instance.MouseManager.PointPosition;
            }
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
           
            spriteBatch = new SpriteBatch(GraphicsDevice);
            model = Content.Load<Model>("sphere");
            effect = Content.Load<Effect>("SampleShader");
            //terrain = new Terrain(Content.Load<Texture2D>("heightmap"));
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            //ICamera cam = GameManager.Instance.CameraManager.Current;
            ////ResetRenderStates();
            //GraphicsDevice.Clear(Color.CornflowerBlue);

            //BeginDraw();
            
            //foreach (ModelMesh mesh in model.Meshes)
            //{
            //    foreach (ModelMeshPart part in mesh.MeshParts)
            //    {
            //        part.Effect = effect;
            //    }
            //    effect.Parameters["View"].SetValue(cam.View);
            //    effect.Parameters["Projection"].SetValue(cam.Projection);
            //    effect.Parameters["World"].SetValue(Matrix.CreateTranslation(Vector3.Zero));
            //    mesh.Draw();
            //}
            //// terrain.Draw(gameTime, cam);
            
            //EndDraw();
            

            //GraphicsDevice.RenderState.FillMode = FillMode.Solid;
            base.Draw(gameTime);
            
        }
    }
}
